#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "nmd_impl.h"
#include "nmd.h"

/*! Generate an mysql dump of an object
 */
#undef __FUNCT__
#define __FUNCT__ "NMDObjectDumpToMySQL"
NMDErrorCode NMDObjectDumpToMySQL(NMD_metadata obj)
{
  NMD_string namesstring,valuesstring;
  int icat,icmp; NMDErrorCode ierr;
  CHECKHASNMDCOOKIE(obj);

  ierr = NMDStringCreate("",&namesstring); NMD_ERR_RETURN(ierr);
  ierr = NMDStringCreate("",&valuesstring); NMD_ERR_RETURN(ierr);

  for (icat=0; icat<obj->ncat; icat++) {
    NMD_metadata_category cat = obj->cats[icat];
    NMD_string catstring;
    CHECKHASNMDCOOKIE(cat);
    ierr = NMDStringCreate(cat->name,&catstring); NMD_ERR_RETURN(ierr);
    for (icmp=0; icmp<cat->ncmp; icmp++) {
      char cmpvalue[45];
      NMD_metadata_item cmp = cat->cmps[icmp];
      CHECKHASNMDCOOKIE(cmp);
      memset(cmpvalue,0,45);
      switch (cmp->t) {
      case NMDInt : sprintf(cmpvalue,"%d",cmp->i); break;
      case NMDReal : sprintf(cmpvalue,"%e",cmp->r); break;
      default :
	continue;
      }
      if (cmpvalue[0]) {
	NMD_string cmpstring,cmpcatstring;
	/* name */
	ierr = NMDStringCreate(cmp->name,&cmpstring); NMD_ERR_RETURN(ierr);
	ierr = NMDStringConcat
	  (0,catstring,':',cmpstring,0,&cmpcatstring); NMD_ERR_RETURN(ierr);
	ierr = NMDStringAppend
	  (0,&namesstring,0,cmpcatstring,','); NMD_ERR_RETURN(ierr);
	ierr = NMDStringDestroy(cmpstring); NMD_ERR_RETURN(ierr);
	ierr = NMDStringDestroy(cmpcatstring); NMD_ERR_RETURN(ierr);
	/* value */
	ierr = NMDStringCreate(cmpvalue,&cmpcatstring); NMD_ERR_RETURN(ierr);
	ierr = NMDStringAppend
	  (0,&valuesstring,0,cmpcatstring,','); NMD_ERR_RETURN(ierr);
	ierr = NMDStringDestroy(cmpcatstring); NMD_ERR_RETURN(ierr);
      }
    }
    ierr = NMDStringDestroy(catstring); NMD_ERR_RETURN(ierr);
  }

  {
    const char *c;
    ierr = NMDStringGetString(namesstring,&c); NMD_ERR_RETURN(ierr);
    printf("INSERT INTO yourtable (%s)\n",c);
    ierr = NMDStringGetString(valuesstring,&c); NMD_ERR_RETURN(ierr);
    printf("VALUES (%s);\n",c);
  }

  return 0;
}


